//------------------------------------------------------------------ 
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_separate_window 
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1  25
#property indicator_level2  75
#property indicator_minimum -5
#property indicator_maximum 105

//
//
//
//
//

extern int                RsiPeriod    = 13;
extern ENUM_APPLIED_PRICE RsiPrice     = PRICE_CLOSE;
extern int                MinMaxPeriod = 10;
extern int                SumPeriod    = 3;
double exs[];
double exsda[];
double exsdb[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,exs);
   SetIndexBuffer(1,exsda);
   SetIndexBuffer(2,exsdb);
   SetIndexBuffer(3,slope);
      IndicatorShortName("Exit swing ("+RsiPeriod+","+MinMaxPeriod+")"); 
   return(0); 
} 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][3];
#define _rsi 0
#define _max 1
#define _min 2

int start() 
{ 
   int i,k,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   if (slope[limit]==-1) CleanPoint(limit,exsda,exsdb);
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double mom  = iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i)-iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i+1);
      double moa  = MathAbs(mom);
      double tmom = iSmooth(mom,RsiPeriod,1,i,0);
      double tmoa = iSmooth(moa,RsiPeriod,1,i,1);
      if (tmoa != 0)
           work[r][_rsi] = MathMax(MathMin((tmom/tmoa+1.0)*50.0,100.00),0.00); 
      else work[r][_rsi] = 50;
           work[r][_min] = work[r][_rsi];
           work[r][_max] = work[r][_rsi];
           for (k=1; k<MinMaxPeriod; k++)
           {
               work[r][_min] = MathMin(work[r][_min],work[r-k][_rsi]);
               work[r][_max] = MathMax(work[r][_max],work[r-k][_rsi]);
           }
           double sumc=0;
           double sume=0;
           for (k=0; k<SumPeriod; k++)
           {
               sumc += work[r-k][_rsi]-work[r-k][_min];
               sume += work[r-k][_max]-work[r-k][_min];
            }
         
         //
         //
         //
         //
         //
         
         if (sume != 0)
               exs[i] = 100.0*sumc/sume;
         else  exs[i] = 0;             
         exsda[i] = EMPTY_VALUE;
         exsdb[i] = EMPTY_VALUE;
         slope[i] = slope[i+1];
            if (exs[i]>exs[i+1]) slope[i] =  1;
            if (exs[i]<exs[i+1]) slope[i] = -1;
            if (slope[i] == -1) PlotPoint(i,exsda,exsdb,exs);
   } 
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSmooth[][10];
double iSmooth(double price,int length, double speed, int r, int instanceNo=0)
{
   if (ArrayRange(workSmooth,0)!=Bars) ArrayResize(workSmooth,Bars); instanceNo *= 5; r = Bars-r-1;
 	if(r<=2) { workSmooth[r][instanceNo] = price; workSmooth[r][instanceNo+2] = price; workSmooth[r][instanceNo+4] = price; return(price); }
   
   //
   //
   //
   //
   //

	double beta  = 0.45*(length-1.0)/(0.45*(length-1.0)+2.0);
	double alpha = MathPow(beta,speed);
   	  workSmooth[r][instanceNo+0] =  price+alpha*(workSmooth[r-1][instanceNo]-price);
	     workSmooth[r][instanceNo+1] = (price - workSmooth[r][instanceNo])*(1-alpha)+alpha*workSmooth[r-1][instanceNo+1];
	     workSmooth[r][instanceNo+2] =  workSmooth[r][instanceNo+0] + workSmooth[r][instanceNo+1];
	     workSmooth[r][instanceNo+3] = (workSmooth[r][instanceNo+2] - workSmooth[r-1][instanceNo+4])*MathPow(1.0-alpha,2) + MathPow(alpha,2)*workSmooth[r-1][instanceNo+3];
	     workSmooth[r][instanceNo+4] =  workSmooth[r][instanceNo+3] + workSmooth[r-1][instanceNo+4]; 
   return(workSmooth[r][instanceNo+4]);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}
